#include <Wire.h>
#include <LiquidCrystal_I2C.h>

const int NUM_SENSORS = 6; // numărul de senzori
int sensorPins[NUM_SENSORS] = {A0, A1, A2, A3, A4, A5}; // pinii analogici de input pentru senzori
int mot_left_st = 10;
int mot_left_nd = 11;
int mot_right_st = 8;
int mot_right_nd = 9;
int ena = 5;
int enb = 6;
LiquidCrystal_I2C lcd(0x27, 16, 2);

void setup() {
  Serial.begin(9600); // inițializez comunicarea serială
  lcd.init();
  lcd.backlight();
  lcd.setCursor(0, 0);
  lcd.print("I'm driving");
  
  pinMode(mot_left_st,OUTPUT); //se stabilesc pinii pentru motoare
  pinMode(mot_left_nd,OUTPUT);
  pinMode(mot_right_st,OUTPUT);
  pinMode(mot_right_nd,OUTPUT);
  pinMode(enb, OUTPUT);
  pinMode(ena, OUTPUT);
}

void loop() {
  int firstsensorValue = analogRead(sensorPins[0]); // read the value from the sensor

  int secondsensorValue = analogRead(sensorPins[1]); // read the value from the sensor

  int thirdsensorValue = analogRead(sensorPins[2]); // read the value from the sensor

  int fourthsensorValue = analogRead(sensorPins[3]); // read the value from the sensor

  int fifthsensorValue = analogRead(sensorPins[4]); // read the value from the sensor

  int sixthsensorValue = analogRead(sensorPins[5]); // read the value from the sensor

  if ((firstsensorValue >= 600 || secondsensorValue >= 600)  && sixthsensorValue < 600) {
      turn_left();
  } else if (firstsensorValue < 600 && sixthsensorValue < 600) {
    go_straight();
  } else if ((sixthsensorValue >= 600 || fifthsensorValue >= 600) && firstsensorValue < 600) {
      turn_right();
  } else if(sixthsensorValue >= 600 && firstsensorValue >= 600) {
    turn_right();
  }
}

void go_straight()
{
  digitalWrite(mot_right_st,LOW);
  digitalWrite(mot_right_nd,HIGH);
  analogWrite(ena, 150); //se stabilesc pinii_pentru_pwm

  digitalWrite(mot_left_st,HIGH);
  digitalWrite(mot_left_nd,LOW);
  analogWrite(enb, 150);
  delay(10);
}

void should_stop()
{
  digitalWrite(mot_left_st,LOW);
  digitalWrite(mot_left_nd,LOW);
  digitalWrite(mot_right_st,LOW);
  digitalWrite(mot_right_nd,LOW);
  analogWrite(ena,0); //se stabilesc pinii_pentru_pwm
  analogWrite(enb,0);
}

void turn_right()
{
  int thirdsensorValue = analogRead(sensorPins[2]); // citește senzorul

  while(thirdsensorValue < 600) {
    digitalWrite(mot_right_st, LOW); // stop motor drept
    digitalWrite(mot_right_nd, LOW);
    analogWrite(ena, 0);
    
    digitalWrite(mot_left_st, HIGH); // mișcă motor stâng
    digitalWrite(mot_left_nd, LOW);
    analogWrite(enb, 150);
    delay(10);

    thirdsensorValue = analogRead(sensorPins[2]); // citește senzorul
  }
}

void turn_left()
{
  int thirdsensorValue = analogRead(sensorPins[2]); // citește senzorul

  while(thirdsensorValue < 600) {
    digitalWrite(mot_right_st, LOW); // mișcă senzorul stâng
    digitalWrite(mot_right_nd, HIGH);
    analogWrite(ena, 150);
    
    digitalWrite(mot_left_st, LOW); // oprește senzorul drept
    digitalWrite(mot_left_nd, LOW);
    analogWrite(enb, 0);
    delay(10);
    thirdsensorValue = analogRead(sensorPins[2]); // citește senzorul
  }
}
